=== debian/changelog ===
hyperscan (4.2.0-2) unstable; urgency=medium

  [ Eduard Sanou ]
  * Use SOURCE_DATE_EPOCH as embedded timestamp to make the build
    reproducible (Closes: #832917).

  [ Robert Haist ]
  * Fix builds (E-march-native) for i386, kfreebsd-amd64, kfreebsd-i386, x32.

 -- Robert Haist <rhaist@mailbox.org>  Fri, 29 Jul 2016 20:49:09 +0200

hyperscan (4.2.0-1) unstable; urgency=medium

  * Initial release (Closes: #824838)

 -- Robert Haist <rhaist@mailbox.org>  Mon, 25 Jul 2016 16:44:23 +0200
