=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Explicitly turn on SSSE3 as it has a broader compatibility
# with oldish hardware than the alternative new AVX2 instruction
# set (>=Haswell) hyperscan uses if available
export DEB_CFLAGS_MAINT_APPEND = -mssse3 -march=core2
export DEB_CXXFLAGS_MAINT_APPEND = -mssse3 -march=core2

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_STATIC_AND_SHARED=1

override_dh_install:
	dh_install --fail-missing
