=== debian/changelog ===
hyperscan (4.3.1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Bundle necessary subset of Boost 1.57 headers to allow compiling.
    There are no plans to provide backports for Boost >1.55 via the Debian
    Boost team. Since only the header part of Boost is needed to build
    hyperscan, we shouldn't need to worry about ABI issues.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 23 Nov 2016 11:22:34 +0100

hyperscan (4.3.1-1) unstable; urgency=medium

  [ Hilko Bengen ]
  * Add gbp.conf

  [ Robert Haist ]
  * New upstream version 4.3.1

 -- Robert Haist <rhaist@mailbox.org>  Mon, 12 Sep 2016 22:28:09 +0200

hyperscan (4.3.0-1) unstable; urgency=medium

  [ Robert Haist ]
  * Set correct Vcs-Browser link
  * Added Dutch translations for debconf provided by Frans Spiesschaert
    (Closes: #834623)

  [ Hilko Bengen ]
  * New upstream version
  * Drop reproducible timestamp patch that was integrated upstream
  * Rename library package to libhyperscan4

 -- Hilko Bengen <bengen@debian.org>  Wed, 24 Aug 2016 23:09:17 +0200

hyperscan (4.2.0-3) unstable; urgency=medium

  [ Robert Haist ]
  * Fix build errors for gcc 6.1.1 by explicitly setting CMAKE_BUILD_TYPE
  * Point Vcs-Git & Vcs-Browser to the src pkg git and not to upstream

  [ SZ Lin ]
  * Added zh_TW translations for debconf

  [ Hilko Bengen ]
  * Update VCS links to anonscm.debian.org
  * Add French debconf translation provided by Julien Patriarca (Closes:
    #833855)
  * Add German debconf translation
  * Add myself to Uploaders

 -- Hilko Bengen <bengen@debian.org>  Tue, 09 Aug 2016 22:10:49 +0200
