=== debian/control ===
--- 
+++ 
@@ -1,21 +1,23 @@
 Source: hyperscan
 Priority: optional
 Maintainer: Robert Haist <rhaist@mailbox.org>
+Uploaders: Hilko Bengen <bengen@debian.org>
 Build-Depends: debhelper (>=9),
                cmake (>=2.8.11),
                ragel (>=6.9),
-               libboost-dev (>=1.57),
-               python (>=2.7)
+#               libboost-dev (>=1.55),
+               python (>=2.7),
+               po-debconf
 Standards-Version: 3.9.8
 Section: libs
 Homepage: https://01.org/hyperscan
-Vcs-Git: https://github.com/01org/hyperscan.git
-Vcs-Browser: https://github.com/01org/hyperscan.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/hyperscan.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/hyperscan.git
 
 Package: libhyperscan-dev
 Section: libdevel
 Architecture: any-i386 any-amd64
-Depends: libhyperscan4.2 (= ${binary:Version}), ${misc:Depends}
+Depends: libhyperscan4 (= ${binary:Version}), ${misc:Depends}
 Description: Development files for the Hyperscan library
  This package contains development libraries, header files and documentation for
  the regular expression matching library libhyperscan. You can either use the
@@ -23,7 +25,7 @@
  .
  libhyperscan only runs on processors with at least SSSE3 support.
 
-Package: libhyperscan4.2
+Package: libhyperscan4
 Architecture: any-i386 any-amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: debconf
