=== debian/changelog ===
hyperscan (4.4.0-1) unstable; urgency=medium

  [ Robert Haist ]
  * Add brazilian / portuguese translations thanks to Adriano Rafael Gomes (Closes: #846528)
  * New upstream version 4.4.0

  [ Sascha Steinbiss ]
  * use secure Vcs-Git
  * add missing build-deps

 -- Robert Haist <rhaist@mailbox.org>  Fri, 20 Jan 2017 10:08:50 +0100
